using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace AsynchCalcPi2005
{
    public partial class AsyncCalcPiForm : Form
    {
        public AsyncCalcPiForm()
        {
            InitializeComponent();
        }

        virtual protected void ShowProgress(string pi, int totalDigits, int digitsSoFar)
        {
            this.resultTextBox.Text = pi;
            this.calcToolStripProgressBar.Maximum = totalDigits;
            this.calcToolStripProgressBar.Value = digitsSoFar;

            if (digitsSoFar == totalDigits)
            {
                this.calcToolStripStatusLabel.Text = "Ready";
                this.calcToolStripProgressBar.Visible = false;
            }

            this.Refresh();
        }

        virtual protected void CalcPi(int digits)
        {
            StringBuilder pi = new StringBuilder("3", digits + 2);
            ShowProgress(pi.ToString(), digits, 0);

            if (digits > 0)
            {
                pi.Append(".");

                for (int i = 0; i < digits; i += 9)
                {
                    int nineDigits = NineDigitsOfPi.StartingAt(i + 1);
                    int digitCount = Math.Min(digits - i, 9);
                    string ds = string.Format("{0:D9}", nineDigits);
                    pi.Append(ds.Substring(0, digitCount));

                    ShowProgress(pi.ToString(), digits, i + digitCount);
                }

            }
        }

        virtual protected void buttonCalc_Click(object sender, EventArgs e)
        {
            this.calcToolStripProgressBar.Value = 0;
            this.calcToolStripProgressBar.Visible = true;
            this.calcToolStripStatusLabel.Text = "Calculating...";

            CalcPi((int)this.decimalPlacesNumericUpDown.Value);
        }

        private void asyncToolStripMenuItem_Click1(object sender, EventArgs e)
        {
            
        }

        private void crashToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new AsyncCalcPiForm2_Thread1_Crash().Show();
        }

        private void sycnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new AsyncCalcPiForm3_Thread2_Sync().Show();
        }

        private void asyncToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            new AsyncCalcPiForm4_Thread3_Async().Show();
        }

        private void asyncSafeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new AsyncCalcPiForm5_Thread4_Async2_Safe().Show();
        }

        private void asyncStopToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new AsyncCalcPiForm6_Thread5_Async3_Stop().Show();
        }
    }

}